/* need more improvements */
/*
 * GdiffOverview widget header
 *
 * Programmed by INOUE Seiichiro <inoue@ainet.or.jp>
 */
#ifndef __GDIFF_OVERVIEW_H__
#define __GDIFF_OVERVIEW_H__

#include <gdk/gdk.h>
#include <gtk/gtkadjustment.h>
#include <gtk/gtkwidget.h>
#include <gtk/gtksignal.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define GTK_TYPE_OVERVIEW            (gdiff_overview_get_type ())
#define GDIFF_OVERVIEW(obj)          GTK_CHECK_CAST (obj, gdiff_overview_get_type (), GdiffOverview)
#define GDIFF_OVERVIEW_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gdiff_overview_get_type (), GdiffOverviewClass)
#define GTK_IS_OVERVIEW(obj)       GTK_CHECK_TYPE (obj, gdiff_overview_get_type ())
	
	
typedef struct _GdiffOverview       GdiffOverview;
typedef struct _GdiffOverviewClass  GdiffOverviewClass;
typedef struct _PaintRange PaintRange;

struct _GdiffOverview
{
	GtkWidget widget;

	gint slider_y;
	gint slider_length;
	GtkAdjustment *adjustment;
	gfloat old_value;
	gfloat old_lower;
	gfloat old_upper;
	gfloat old_page_size;

	/* range display */
	GSList *range_list;/* Singly linked list of PaintRange */
};

struct _GdiffOverviewClass
{
  GtkWidgetClass parent_class;
};

/* Internal data structure */
struct _PaintRange {
	gdouble begin;/* 0.0 - 1.0 */
	gdouble end;/* 0.0 - 1.0 */
};

guint      gdiff_overview_get_type   (void);
GtkWidget* gdiff_overview_new        (GtkAdjustment *adjustment);
void       gdiff_overview_size       (GdiffOverview      *overview,
									gint                 width,
									gint                 height);
void gdiff_overview_set_adjustment (GdiffOverview *overview,
								  GtkAdjustment *adjustment);

void gdiff_overview_insert_paintrange(GdiffOverview *overview, gdouble begin, gdouble end);

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* __GDIFF_OVERVIEW_H__ */
